#-------------------------------------------------------------------------------
# Name:        asciicleaner
#-------------------------------------------------------------------------------
#!/usr/bin/env python



#-------------------------------------------------------------------------------
# imports we need
import sys
import os
#
from optparse import OptionParser
#
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, "../.."))
sys.path.append(parpath)
#
# import the helper classes
from TWLCHelper import *
#-------------------------------------------------------------------------------









#-------------------------------------------------------------------------------
def WlcDoCleanUpDangerousAscii(str):
    str2 = str.decode('utf-8','ignore')
    #str3 = str2.encode('latin-1','ignore')
    #str3 = str2.encode('iso-8859-1','ignore')
    str3 = str2.encode('ascii','ignore')
    return str3
#-------------------------------------------------------------------------------



#---------------------------------------------------------------------------
def DoConversionWork(infilename,outfilename,helper):
    # open files
    infile = open(infilename,"r")
    outfile = open(outfilename,"w")
    # get input file contents as string
    textin = infile.read()
    # ok now we need to handle some evil high ascii that can upset it
    textout = WlcDoCleanUpDangerousAscii(textin)
    # write output
    outfile.write(textout)
    # done!

    # success
    return 0
#---------------------------------------------------------------------------



































#---------------------------------------------------------------------------
def RunWithCommandlineOptions(comlineargs):

    # user helper for parsing commandline optins
    helper = TWLCHelper()
    helper.set_usage("call with --infile \"%INFILE%\" --outfile \"%OUTFILE%\"")
    # commandline options
    helper.get_parser().add_option("", "--infile", dest="infile", help="input file (full path)")
    helper.get_parser().add_option("", "--outfile", dest="outfile", help="output file (full path)")
    # parse commandline
    helper.ParseCommandlineParameters(comlineargs)

    # get params
    infilename=helper.get_arg("infile","",True)
    outfilename=helper.get_arg("outfile","",True)

    # ok now do the work
    return DoConversionWork(infilename,outfilename,helper)
#---------------------------------------------------------------------------







#---------------------------------------------------------------------------
def main(comlineargs=None):
    #parse commandline paramers
	return RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------






#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


