#-------------------------------------------------------------------------------
# Name:        search
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
import sys
import os
import types
from types import *
import json
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from TSearch import *
#-------------------------------------------------------------------------------







#-------------------------------------------------------------------------------
# defines and constants
DEF_TSearch_GoogleApi_GoogleApiKey = ""
#-------------------------------------------------------------------------------














#---------------------------------------------------------------------------
class TSearch_GoogleWebApi(TSearch):

    def __init__(self):
        # parent init
        super(TSearch_GoogleWebApi, self).__init__()
        self.key=''

    def __del__(self):
        pass


    def get_searchenginename(self):
        return "core.googleapi"


    def ParseDerivedCommandlineArgs(self):
        # parse any derived object specific commandline options
        self.helper.get_parser().add_option("", "--key", dest="key", help="optional google api key")
        self.helper.get_parser().add_option("", "--num", dest="num", help="optional number of results to get; you can request UP TO 8 (no more or it wont succeed) results; default is 4")
        pass


    def BuildSearchUrlFromSearchString(self,search):
        # build params
        self.key = self.helper.get_arg("key",DEF_TSearch_GoogleApi_GoogleApiKey,False)
        params = "v=1.0&q="+self.helper.urlquoteargs(search)
        # add api key
        if self.key!="":
            params += "&key=" + self.key
        # form url
        url = "http://ajax.googleapis.com/ajax/services/search/web?"+params
        # extra args?
        urlargs = self.helper.get_arg("urlargs","",False)
        if (urlargs!=""):
            url = url + "&"+urlargs
        num = self.helper.get_arg("num","",False)
        if (num!=""):
            url = url + "&rsz="+num
        #print url
        #exit(1)
        # return it
        return url




    def ParseWebPageContentIntoResults(self,search,content,baseresult):
        # parse content of page request into results
        results = []

        #jsonc = simplejson.loads(content)
        jsonc = json.loads(content)

        # test -- simulate error
        #jsonc['responseData']=None
        #jsonc['responseDetails']="you are attacking us!"

        #print jsonc
        #exit(1)

        if (jsonc==None) or ('responseData' not in jsonc) or (jsonc['responseData']==None) or ('results' not in jsonc['responseData']):
            # error, bad data returned
            result=dict()
            emsg="Google did not reply to search request."
            if ('responseDetails' in jsonc):
                emsg+="\nGOOGLE ERROR: "+jsonc['responseDetails']+".";
            if (self.key==""):
                emsg+="\nHINT: Try seting google websearch api key value to increase search allowances."
            result[self.helper.get_toolerrorvarname()]=emsg
            results.append(result)
            #print results
            #exit(1)
            return results

        jsonresults = jsonc['responseData']['results']
        resultcount = len(jsonresults)
        #print "RESULTS: "+str(resultcount)
        resultindex=0
        for jresult in jsonresults:
            # start with base result
            result = dict(baseresult)
            # now parameters
            result["linktitle"]=self.helper.UnEscapeHtmlText(jresult["titleNoFormatting"])
            result["search"]=search
            #result["url"]=helper.UnEscapeHtmlText(jresult["url"])
            result["url"]=self.helper.UnEscapeUrl(jresult["url"])
            result["excerpthtml"]=jresult["content"]
            # score with first result highest
            scoreval=(100-resultindex)
            result["score"]=str(scoreval)
            # add it
            results.append(result)
            # increment index
            resultindex=resultindex+1

        return results
#---------------------------------------------------------------------------






























































































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object

    searcher = TSearch_GoogleWebApi()

    # and ask it to run with commandline options
    retcode = searcher.RunWithCommandlineOptions(comlineargs)

    return retcode
#---------------------------------------------------------------------------




#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


